Redmine - Defect #3724

Mercurial repositories display revision ID instead of changeset ID
2009-08-10 05:14 - Scot Herring

Status: Closed Start date: 2009-08-10
Priority: Low Due date:

Assignee: Toshi MARUYAMA % Done: 0%
Category: SCM Estimated time: 0.00 hour
Target version: 1.2.0

Resolution: Fixed Affected version:

Description

Redmine exposes Mercurial's revision IDs (one-up decimal number, similar to Subversion) as the primary means of referring to
changesets, rather than the changeset ID (strings of hex digits, like Git). While this does work, it's explicitly discouraged in Mercurial's
documentation.

From the FAQ:

You should always use some form of changeset ID rather than the local revision number when discussing revisions with other
Mercurial users as they may have different revision numbering on their system.

And the page on revision numbers says:
Pitfalls
Revision numbers referring to changesets are very likely to be different in another copy of a repository. Do not use them to talk
about changesets with other people. Use the changeset ID instead.

(Emphasis theirs.)

The behavior of hgweb.cgi (the web frontend that comes with Mercurial) is to expose only the short-form changeset IDs. However it
allows entering a revision ID into the URL as well. So the following URLs will bring up the same patch:

e http://schismtracker.org/hg/rev/fi80face224f
e http://schismtracker.org/hg/rev/1846
e http://schismtracker.org/hg/rev/20090805 (as hgweb allows entering tags as well -- | dunno if you want to get that elaborate :)

This is probably the sanest path to take with Redmine, in terms of keeping old URLs functioning and also to more or less parallel the
way that Git repos are managed.

Issue #3567 might be tangentially related to this.

Related issues:

Related to Redmine - Feature #6092: Truncate Git revision labels in Activity ... Closed 2010-08-09
Related to Redmine - Defect #4924 : mercurial reader disregard information fro... Closed 2010-02-24
Related to Redmine - Defect #6681: Mercurial, Bazaar and Darcs auto close iss... Closed 2010-10-15
Related to Redmine - Feature #4455: Mercurial overhaul Closed 2009-12-21
Related to Redmine - Defect #7518: Mercurial diff can be wrong if the previou... Closed 2011-02-02
Related to Redmine - Defect #8030: Bazaar integration doesn't notice new comm... New 2011-03-31
Related to Redmine - Feature #5501: Git: Mercurial: Adding visual merge/branc... Closed 2010-05-11

Associated revisions

Revision 4613 - 2011-01-02 10:45 - Toshi MARUYAMA
Changing revision label and identifier at SCM adapter level (#3724, #6092)

Contributed by Yuya Nishihara.

Revision 4654 - 2011-01-08 07:24 - Toshi MARUYAMA
scm: mercurial: accept both of revision and nodeid as changeset id (#3724).
Contributed by Yuya Nishihara.

Revision 4661 - 2011-01-08 13:51 - Toshi MARUYAMA

scm: mercurial: cat test for accept both of revision number and changeset id (#3724).
Revision 4662 - 2011-01-08 14:51 - Toshi MARUYAMA

scm: mercurial: fix diff and test for accept both of revision number and changeset id (#3724).
Diff of changeset can be wrong if the previous changeset isn't the parent.

Revision 4663 - 2011-01-09 02:30 - Toshi MARUYAMA

scm: mercurial: annotate accepts both of revision number and changeset id (#3724).

Change annotate revision label to Mercurial style '4:def6d2f1254a’
and use identifier.

Revision 4664 - 2011-01-09 03:13 - Toshi MARUYAMA

scm: mercurial: functional test for accept both of revision number and changeset id (#3724).
Revision 4686 - 2011-01-11 06:15 - Toshi MARUYAMA

scm: mercurial: diff '-c' option supports above Mercurial 1.2 (#3724, #7253).
r4662 fails in old Mercurial.

Revision 4694 - 2011-01-11 17:02 - Toshi MARUYAMA

scm: use scmid for "commit:xxx" link if available (#3724).

scmid is more solid than revision number.

Contributed by Yuya Nishihara.

Revision 4695 - 2011-01-11 17:03 - Toshi MARUYAMA

scm: mercurial: use scmid as identifier (#3724).

Contributed by Yuya Nishihara.

Revision 4696 - 2011-01-11 17:03 - Toshi MARUYAMA

scm: mercurial: add "commit:xxx" and "rNN" link test for mercurial (#3724).

Revision 4697 - 2011-01-11 17:03 - Toshi MARUYAMA

scm: mercurial: use revision text mercurial style "2:400bb8672109" (#3724).

Contributed by Yuya Nishihara.

Revision 4698 - 2011-01-11 17:04 - Toshi MARUYAMA
scm: changing two revision diff text at SCM adapter level (#3724).

Revision 4699 - 2011-01-11 17:04 - Toshi MARUYAMA

scm: mercurial: change two revision diff text of mercurial (#3724).

For example, "4:def6d2f1254a 2:400bb8672109".

Revision 4705 - 2011-01-13 13:05 - Toshi MARUYAMA

scm: mercurial: unit lib test for entries accept both of revision number and changeset id (#3724, #3421)

Revision 4733 - 2011-01-21 14:22 - Toshi MARUYAMA

scm: use format_revision() for history, view and annotate (#3724).

Revision 4734 - 2011-01-21 14:22 - Toshi MARUYAMA
scm: functional test of using format_revision() for annotate (#3724).

Revision 4857 - 2011-02-16 16:43 - Toshi MARUYAMA
scm: mercurial: add identifier to entry.lastrev (#3724, #3421).

Revision 4858 - 2011-02-16 16:43 - Toshi MARUYAMA

scm: in repository tree, use find_changeset_by_name instead of changesets.find_by_revision (#3724, #3421).

Mercurial revision numbers are far too brittle.
Please see #6681 description.

History

#1 - 2009-09-17 23:34 - Luke Hoersten

Yeabh this is a problem for us too. It's very fragile and something as simple as removing a changeset with screw up ALL the links. This really needs to
be fixed.

#2 - 2009-12-15 14:42 - Peter Fern

The attached patch addresses your concern, and I'm all for moving away from the ambiguous revision numbers, but this sort of behavioural change

probably requires a configuration option, since it will definitely break any existing r##-style references... comments?

#3 - 2009-12-15 14:44 - Peter Fern

- File mercurial _scmid_authoritative.patch added

#4 - 2009-12-15 15:10 - Peter Fern

Actually, there are some further changes to be made in app/models/repository/mercurial.rb

#5 - 2009-12-15 15:14 - Luke Hoersten

Peter Fern wrote:

The attached patch addresses your concern, and I'm all for moving away from the ambiguous revision numbers, but this sort of behavioural
change probably requires a configuration option, since it will definitely break any existing r##-style references... comments?

Probably a conversion script of the r##-style references to hashes would be best. Thanks for doing this!

#6 - 2009-12-18 07:59 - Peter Fern

Just an update - | have a significant Mercurial patch near completion that addresses this issue, plus a number of others, please ignore my previous
attachment.

#7 - 2009-12-18 08:52 - Scot Herring

Awesome. Look forward to it.

| don't see why it'd break ri##, though - like | mentioned above, hg understands several kinds of references to changesets, so what's preventing
redmine from allowing all three and just passing along whatever identifier to the client?

#8 - 2009-12-18 09:10 - Peter Fern

There are two keys in the Redmine database - revision and scmid, however Mercurial has 3 identifiers: revision, short changeset ID, and full
changeset ID. Since revision is likely to get clobbered, and even the short changeset ID is not guaranteed to remain unique, I'd like to move to using
the short ID as the revision, and the full ID as the scmid, since this is the only way we'll have a guaranteed unique identifier in the DB, and if the
revision number gets routinely clobbered by merges, it's pretty useless anyway, since any references to it will now refer to some other commit.

#9 - 2009-12-18 14:24 - Luke Hoersten

Peter Fern wrote:

Just an update - | have a significant Mercurial patch near completion that addresses this issue, plus a number of others, please ignore my
previous attachment.

If you're working on a big Mercurial update, you may want to take a look at issue r3421. Mercurial is more or less useless without it in Redmine.

#10 - 2009-12-18 14:24 - Luke Hoersten

Luke Hoersten wrote:
Peter Fern wrote:
Just an update - | have a significant Mercurial patch near completion that addresses this issue, plus a number of others, please ignore my
previous attachment.

If you're working on a big Mercurial update, you may want to take a look at issue r3421. Mercurial is more or less useless without it in Redmine.

Sorry that's issue #3421.

#11 - 2009-12-19 02:08 - Peter Fern

| wouldn't say that - the only thing that doesn't work is file sizes... my patch incorporates branch and tag support like git, plus major performance
improvements. I'll have it up in the next day or so. I've added a comment to #3421

#12 - 2009-12-19 03:54 - Luke Hoersten

Peter Fern wrote:

| wouldn't say that - the only thing that doesn't work is file sizes... my patch incorporates branch and tag support like git, plus major performance
improvements. I'll have it up in the next day or so. I've added a comment to #3421

You understand what #3421 is fixing right? Redmine pulls the history from the repo but file access is attempted on the file system instead of using 'hg
cat' to grab what's in the changeset specified.

#13 - 2009-12-19 04:15 - Peter Fern

I think you'll find that's incorrect, and looking at the patch, it doesn't modify the 'cat' method in any way other than to add a default identifier of 'tip'.
The only file access the the Mercurial code is to get file sizes, which I'd be happy to see resolved since it's the last functional hole in my patchset.

#14 - 2010-03-03 18:23 - Ted Lilley

As a user of the Mercurial plugin, | want to add my $.02 here.

Just as there is a reason for the globally-unique changeset hash id, there is also a reason for the integer revision id as well. | currently rely on
Redmine as the source for access to the integer id, and removing it completely would break my build system implementation.

While a changeset hash is useful when discussing revisions between developers, it is unfortunately both completely unsuitable for use in build
numbering of packages as well as being hostile to the human eye. Because of the necessity of numbering our builds with the revision number, in
order to trace back any build package to the source code which created it, we simply make sure that our developers know of the mutability of the
integer revision id and use the build repository as its authoritative source. This is simply the added cost of using a system like Mercurial, that you
have to keep in mind something extra like the scope of the revision id.

It's not simply a matter of saying "suck it up, use the hash", either. When building .NET assemblies, the revision number must fit within a 16-bit
integer. A hash can't possibly do this. Even if it were possible, however, | still wouldn't inflict hash numbers on our customers as a means of
identifying a package.

So, whatever change you make, | would ask that both it preserve the integer revision id, as well as allowing r-style links in Redmine and being

available in both the Repository view as well as the atom feed for the repository. Otherwise, Redmine's mercurial functionality will be significantly less
useful to developers like me.

#15 - 2010-03-03 18:40 - Luke Hoersten
From the Mercurial book :
[...] the same number in two different clones of a repository may identify different changesets.
What that means is if you swap out the repo for a modified clone, potentially all your short numbers which you've "hardcoded" into the Redmine
issues/comments would be invalidated.

I want my Redmine comments to refer to a specific changeset, not a specific clone's changeset. Perhaps if you're using Mercurial in a more
centralized manor this is fine, but my team doesn't work that way.

Ted Lilley wrote:
As a user of the Mercurial plugin, | want to add my $.02 here.

Just as there is a reason for the globally-unique changeset hash id, there is also a reason for the integer revision id as well. | currently rely on
Redmine as the source for access to the integer id, and removing it completely would break my build system implementation.

While a changeset hash is useful when discussing revisions between developers, it is unfortunately both completely unsuitable for use in build
numbering of packages as well as being hostile to the human eye. Because of the necessity of numbering our builds with the revision number,
in order to trace back any build package to the source code which created it, we simply make sure that our developers know of the mutability of
the integer revision id and use the build repository as its authoritative source. This is simply the added cost of using a system like Mercurial, that
you have to keep in mind something extra like the scope of the revision id.

It's not simply a matter of saying "suck it up, use the hash", either. When building .NET assemblies, the revision number must fit within a 16-bit
integer. A hash can't possibly do this. Even if it were possible, however, | still wouldn't inflict hash numbers on our customers as a means of
identifying a package.

So, whatever change you make, | would ask that both it preserve the integer revision id, as well as allowing r-style links in Redmine and being

available in both the Repository view as well as the atom feed for the repository. Otherwise, Redmine's mercurial functionality will be
significantly less useful to developers like me.

#16 - 2010-03-03 19:15 - Toshi MARUYAMA
- % Done changed from 0 to 80

Please see #4455 - Mercurial overhaul.
#17 - 2010-03-03 19:38 - Toshi MARUYAMA
Luke Hoersten wrote:
From the Mercurial book :
[...] the same number in two different clones of a repository may identify different changesets.

What that means is if you swap out the repo for a modified clone, potentially all your short numbers which you've "hardcoded" into the Redmine
issues/comments would be invalidated.

This is a very serious problem. But there is no way to resolve this problem simply. Because scmid of changeset table is not unique and revision is
unique.

#18 - 2010-03-13 04:03 - Toshi MARUYAMA
Luke Hoersten wrote:

What that means is if you swap out the repo for a modified clone, potentially all your short numbers which you've "hardcoded" into the Redmine
issues/comments would be invalidated.
#19 - 2010-03-13 06:05 - Toshi MARUYAMA
- File hg-overhaul-000.png added

- File hg-overhaul-001.png added

- File hg-overhaul-002.png added

- File hg-overhaul-003.png added

- % Done changed from 80 to 90

| finish testing of last big feature of #4455.

This feature is "old rNN record on DB and wikis can not delete".
http://github.com/marutosi/redmine/tree/hg-overhaul-0.9
http://github.com/marutosi/redmine/commit/30845a8c8ed51a71beb6e1d4df4dfbcf3a55c444

#20 - 2010-05-17 01:04 - Ammler _

| really hope, Mercurial will at least keep the option to use the revision number. That is in fact one of the big advantages compared to git, | am aware
of the possibility to have same repo with different orders of changesets, but that doesn't matter, if you define server/buildsystem repo as master repo.

Please keep at least revision number for Mercurial as option.
| also changed hgweb to show revision numbers instead short hashes.

#21 - 2010-05-17 02:23 - Toshi MARUYAMA

Thank you for your feedback.
Yuya's #4455 new implementation keeps redmine original DB structure.
Please see http://www.redmine.org/issues/4455#note-78 .

#22 - 2011-01-08 06:11 - Toshi MARUYAMA
- Status changed from New to 7

- Assignee set to Toshi MARUYAMA

- Target version set to 1.2.0

- % Done changed from 90 to 0

#23 - 2011-01-08 08:56 - Yuya Nishihara

To Toshi: JFTR, the arguments of assert_equal are expected, actual

r4654 trunk/test/unit/repository_mercurial_test.rb

assert_equal @repository.find_changeset_by_name (r).revision, '2'
should be
assert_equal '2', @repository.find_changeset_by_name (r) .revision
#24 - 2011-01-08 09:45 - Toshi MARUYAMA
Yuya Nishihara wrote:

To Toshi: JFTR, the arguments of assert_equal are expected, actual

r4654 trunk/test/unit/repository_mercurial_test.rb

(-]

should be
(-]

| fixed and committed. Thanks.

#25 - 2011-01-25 12:32 - Toshi MARUYAMA
- File before-link.png added

- File before-repository.png added

- File after-annotate.png added

- File after-link-id.png added

- File after-link-revno.png added

- File after-repository.png added

- File before-annotate.png added

- Status changed from 7 to Closed

- Resolution set to Fixed

| think there are two cases of revision number inconsistency.

e History editing (hg strip, hg rebase etc.)
¢ Replacing repository

If you did history editing, you need to delete repository from redmine and re-add it.
There are some feature issues of re-syncing #1273.

About replacing repository, | wrote at #6681 description.

| think Mercurial user should not use "rNN" in wiki.
If someone wrote "rNN" in wiki, it is user's own risk.
#6681 changed auto close issue text from "rNN" to "commit:XXX".

Redmine stores revision number and changeset id in database.
To resolve this issue, we changed as following.

Change revision text to Mercurial style "2:400bb8672109"

Change revision link from revision number to changeset id

Redmine URL accepts both of revision number and changeset id

diff, cat and annotate accepts both of revision number and changeset id

Before

&™ testBd - / - Repositor »

a = & [O 192.168.11.7:5000/projects/test00/repository

Home My page Projects Administration Help Logged in as admin My account Sign out [« |

test00 seerch: |

Overview  Activity Issues  MNew issue Gantt Calendar News Documents  Wiki Files QGGG  Settings

root illls statistics | Revision: [~
Name Size  Revision Age Author Comment
& | _) images
@ | _J sources
.hgtags ? 7 Jjsmith  Added tag tag_test.00 for changeset 6987191f453a
= README ? 1 Jjsmith  Added 2 files and modified one.

Latest revisions

# Date Author Comment

E*@' 01/01/2000 12:00 am Jsmith Added tag tag-init-revision for changeset 0885933ad4f6

15 jmfﬂ 05:00 am jsmith copy README

4 U= UT/UT/Z002 06:00 pm Jsmith create new test branch with some chars

13 © © 01/01/1989 01:00 pm Jsmith Copied 2 files

12 © © 03/01/1990 02:00 pm jsmith Modified sql_escape/underscore_dir/understrike_file.txt

11 © © 02/01/1990 08:00 am Jjsmith Modified sgl_escape/percent%dir/percent%filel.txt and sql_escape/underscore_file.txt

10 © © 01/01/1990 10:00 am Jsmith Modified sql_escape/percent%dir/percent%filel.txt

a O 0 na/n1/2001 0700 am icmith _ard SO escape test files ||
192.168.11.7:5000/projects/test00/repository/revisions/16  __ . _ -
&7 test00 - Revision 16 - red... =

&o G o lO 192.168.11.90:4000/projects/test00/repository/revisions/16

Home My page Proje Administration Help
test00

Overview  Activity Issues MNew issue Gantt Calendar News Documents Wiki Files QGEGIGIYM Settings

REViSiDn 16 « Previous | Mext = |15—

ID: 4eddb4ed 552
Added by jsmith about 11 years ago

Added tag tag-init-revision for changeset DB85933ad4f6
Files

View differences 0 added @ modified @ copied @ renamed @ deleted

o .hgtags

™% test00 - /README - Annot..,

o Q@ @ [O 192.168.11.90:4000/projects/test00/repository/revisions/6/annotate/README

Home My page Projects Administration Help
test00

Overview  Activity Issues MNew issue Gantt Calendar News Documents Wiki Files JGEGIIGIE Settings

root / README @ 6 il Statistics | Revision: [

1as admin My account Sign out B

History | View | Annotate | Download
1 1 jsmith  Mercurial test repository
6 jsmith

2
3 B jsmith Mercurial is a distributed version control system. Mercurial is dedicated to speed and efficiency with a sane user interface.
4 % jsmith It is written in Python.

Revision 6

192.168.11.90:4000/projects/test00/repository/revisions/6 [~}

After

&% test00 - / - Repository - R.. *

&o (& @ |® 192.168.11.90:5000/projects/test00/repository

Home My page Projects Administration Help

test00 Search: —

Overview  Activity Issues Newissue Gantt Calendar Mews Documents Wiki Files ESNEIGIE Settings

root illy Statistics | Revision: |
Name Size Revision Age  Author Comment

a ] images

@ ] sources

hgtags 7 7:3c3b3cBcbab8 jsmith  Added tag tag_test.00 for changeset 69871914534
=| README 7 1:9d5b5b004199 jsmith  Added 2 files and modified one,
Latest revisions
# Date Author Comment

16:4cddb~4t\45f!¥_ @ 01/01/2000 12:00 am jsmith Added tag tag-init-revision for changeset 0885933ad4f6

15:933caB60293d7 [ Revision 16:4cddb4easfs? jsmith copy README

14:24ea8892e2ec U T/ U 7 ZU0UZ UL0u [T jsmith create new test branch with some chars

13:32330eb32958 © © 01/01/1989 01:00 pm jsmith Copied 2 files

12:a3072136d74b0 © © 03/01/1990 02:00 pm jsmith Modified sql_escape/underscore_dir/understrike_filetxt

162.168.11,5075000/projcis/test00jiepository revisionsiacddbaedstsa dified sal_escape/percentdit/percentiéfilel xt and g
&™% test0O0 - Revision 16:4cdd... =

o & [O 192.168.11.90:5000/projects/test00/repository/revisions/4cddbdedsfs2 3 P A
e

Home My page Projects Administration Help Logged in as admin My nt Sign out n

test00 serc:

Overview  Activity Issues New issue Gantt Calendar Mews Documents Wiki  Files JGEWIIIGITE  Settings

Revision 16:4cddb4e45f52 « Previous | Next » [acaabaessi

10: 4eddbded 552
Added by jsmith about 171 years ago

Added tag tag-init-revision for changeset 0B85933ad4f6

Files

View differences @ added @ modified @ copied @ renamed @ deleted

o .hgtags

&™% test0 - Revision 16:4cdd... »

o S o @ 192.168.11.90:5000/projects/test00/repository/revisions/16 'i'.‘f] - %'ﬁ‘ L
Home My page Pro : Administration Help |

{ in as admin My nt Sign out n

test00

Overview  Activity Issues MNew issue Gantt Calendar MNews Documents Wiki Files QEEJINGITE Settings

Revision 16:4cddb4e45f52 « Previous | Next » —Il&

1D: 4eddbded 552
Added by jsmith about 11 years ago

Added tag tag-init-revision for changeset 088593 3ad4f6
Files
View differences @ added @ modified @ copied @ renamed @ deleted

hgtags

4]
£™4 test00 - /README - Annot... =

<§3° I\_LQ‘ @f [O 192.168.11.90:5000/projects/test00/repository/revisions/7fab6ce80d87/annotate/README

Home My page Projects Administration Help ogged in as admin My account Sign out B

testoo Search: —

Overview  Activity Issues MNew issue Gantt Calendar MNews Documents Wiki Files QGGG Settings

root / README @ 6:7fab6ce80d87 ills Statistics | Revision: [7fabbcesod

History | View | Annotate | Download

1 1:9d5b5b004199  jsmith Mercurial test repository
2 B:7fabBceB0d87  jsmith

Mercurial is a distributed version control system. Mercurial is dedicated to speed and efficiency with a sane user
interface.

4 B:7fabBceB0dBY  jsmith It is written in Python.

3 B:7fabBceB0d87  jsmith

| Revision 6:7fab6ce80d87 |

4]

192.168.11.90:5000/projects/test00/repository/revisions/7fab6ce80d87

Files

mercurial_scmid_authoritative.patch 2.89 KB 2009-12-15 Peter Fern
hg-overhaul-000.png 8.77 KB 2010-03-13 Toshi MARUYAMA
hg-overhaul-001.png 11.4 KB 2010-03-13 Toshi MARUYAMA
hg-overhaul-002.png 13.7 KB 2010-03-13 Toshi MARUYAMA
hg-overhaul-003.png 25 KB 2010-03-13 Toshi MARUYAMA
before-link.png 53.9 KB 2011-01-25 Toshi MARUYAMA
before-repository.png 105 KB 2011-01-25 Toshi MARUYAMA
after-annotate.png 81.4 KB 2011-01-25 Toshi MARUYAMA
after-link-id.png 55.7 KB 2011-01-25 Toshi MARUYAMA
after-link-revno.png 54.5 KB 2011-01-25 Toshi MARUYAMA
after-repository.png 93.3 KB 2011-01-25 Toshi MARUYAMA
before-annotate.png 68.9 KB 2011-01-25 Toshi MARUYAMA
